package com.vendor.burn.preferences;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import com.vendor.burn.Messages;
import com.vendor.burn.preferences.FastbootPreferences;
import com.vendor.burn.preferences.PreferenceConstants;
import org.eclipse.jface.preference.BooleanFieldEditor;
import org.eclipse.jface.preference.FieldEditor;
import org.eclipse.jface.preference.FieldEditorPreferencePage;
import org.eclipse.jface.preference.IntegerFieldEditor;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.IWorkbenchPreferencePage;

public class TFTPPreferencePage extends FieldEditorPreferencePage implements IWorkbenchPreferencePage, PreferenceConstants {
  public static final String ID = "com.vendor.burn.preferences.TFTPPreferencePage";
  
  public static final int TFTP_BLOCKSIZE_MAX = 1468;
  
  private static final int TFTP_BLOCKSIZE_MIN = 512;
  
  private BooleanFieldEditor tftpCrcEditor;
  
  private BooleanFieldEditor winSizeOpenEditor;
  
  private IntegerFieldEditor tftpBlockCountEditor;
  
  private IntegerFieldEditor losingPackageCountEditor;
  
  private BooleanFieldEditor losingpackageEditor;
  
  public TFTPPreferencePage() {
    super(1);
  }
  
  public void init(IWorkbench workbench) {
    setPreferenceStore(FastbootPreferences.getPreferenceStore());
  }
  
  protected void createFieldEditors() {
    Composite parent = getFieldEditorParent();
    IntegerFieldEditor tftpSpeedEditor = new IntegerFieldEditor("vendor.burn.tftp.speed", Messages.TFTPPreferencePage_TFTP_SPEED, parent);
    tftpSpeedEditor.setValidRange(1, 2147483646);
    addField((FieldEditor)tftpSpeedEditor);
    this.losingpackageEditor = (BooleanFieldEditor)new Object(this, "vendor.burn.tftp.losingpackage.enable", Messages.TFTPPreferencePage_DEAL_WITH_LOSING_PACKAGE, parent, parent);
    addField((FieldEditor)this.losingpackageEditor);
    this.losingPackageCountEditor = new IntegerFieldEditor("vendor.burn.tftp.losingpackage.count", Messages.TFTPPreferencePage_MAX_LOSING_PACKAGES, parent);
    addField((FieldEditor)this.losingPackageCountEditor);
    this.losingPackageCountEditor.setEnabled(FastbootPreferences.getBoolean("vendor.burn.tftp.losingpackage.enable"), parent);
    this.losingPackageCountEditor.setValidRange(1, 2147483646);
    IntegerFieldEditor tftpRetryCountEditor = new IntegerFieldEditor("vendor.burn.tftp.retry.count", Messages.TFTPPreferencePage_TFTP_RETRY_COUNT, parent);
    addField((FieldEditor)tftpRetryCountEditor);
    tftpRetryCountEditor.setValidRange(0, 2147483646);
    IntegerFieldEditor tftpNoResponseTimeoutEditor = new IntegerFieldEditor("vendor.burn.tftp.timeout.noresponse", Messages.TFTPPreferencePage_TFTP_NO_RESPONSE_TIMEOUT, parent);
    addField((FieldEditor)tftpNoResponseTimeoutEditor);
    tftpNoResponseTimeoutEditor.setValidRange(3, 2147483646);
    this.tftpCrcEditor = (BooleanFieldEditor)new Object(this, "vendor.burn.tftp.crc.check", Messages.TFTPPreferencePage_TFTP_CRC_CHECK, parent);
    addField((FieldEditor)this.tftpCrcEditor);
    this.winSizeOpenEditor = (BooleanFieldEditor)new Object(this, "vendor.burn.tftp.windowSize.open", Messages.TFTPPreferencePage_TFTP_WindowSize_Open, parent, parent);
    addField((FieldEditor)this.winSizeOpenEditor);
    this.tftpBlockCountEditor = new IntegerFieldEditor("vendor.burn.tftp.windowSize.blockCount", Messages.TFTPPreferencePage_TFTP_WindowSize_BlockCount, parent);
    addField((FieldEditor)this.tftpBlockCountEditor);
    this.tftpBlockCountEditor.setEnabled(FastbootPreferences.getBoolean("vendor.burn.tftp.windowSize.open"), parent);
    this.tftpBlockCountEditor.setValidRange(1, 3);
    IntegerFieldEditor tftpBlockSizeEditor = new IntegerFieldEditor("vendor.burn.tftp.windowSize.blockSize", Messages.tftpPreferencePageBlockSize, parent);
    addField((FieldEditor)tftpBlockSizeEditor);
    tftpBlockSizeEditor.setValidRange(512, 1468);
  }
  
  private void setTftpBlock(boolean isAvailable, Composite parent) {
    if (this.tftpBlockCountEditor != null) {
      this.tftpBlockCountEditor.setEnabled(isAvailable, parent);
      if (!isAvailable) {
        this.tftpBlockCountEditor.setStringValue("1");
      } else {
        this.tftpBlockCountEditor.setStringValue("3");
      } 
    } 
  }
}
